.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include \masm32\include\windows.inc                         
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc
include \masm32\include\advapi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\masm32.lib

include \masm32\macros\macros.asm

S macro	pdata:VARARG 
	LOCAL Buff
.data
	ifidni <pdata>,<>            
		Buff db 0        
	else            
		Buff db pdata,0
	endif
.code
	exitm <OFFSET Buff>
endm

LVSORT struct
	handle		dd	?
	direction	dd	?
	column		dd	?
	Gtype		dd	?
LVSORT ENDS
;-----------------------------------------
HDRIMAGE struct
	dwItem		DD	?
	dwDir		DD	?
HDRIMAGE ENDS

.CONST
	TOPMSG		equ	2048

.DATA
	MsgTable	DD	TOPMSG DUP (?)
	szColumn0	DB	"Column 0",0
	szColumn1	DB	"Column 1",0
	szColumn2	DB	"Column 2",0
	szColumn3	DB	"Column 3",0

	hInstance	DD 	?
	icc	 	DQ	3FFF00000008h
	hDlg		DD	?
	hListView	DD	?
	hHeader		DD	?
	hClipData	DD	?
	hIml		DD	?
	
	buffer		DB	256 DUP (?)
	Glvsort		LVSORT	<>

	hBrush		DD	?
	hLVBrush	DD	?
	
	ArialFont	LOGFONT	<-13,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Arial">
	hArialFont	DD	?
	hdimage		HDRIMAGE <-1,0>

.CODE

LVAddItem proc Image,Col0,Col1,Col2,Col3
	LOCAL LVItem:LV_ITEM
	LOCAL szItemID[16]:BYTE
	LOCAL ItemID:DWORD

	invoke	SendMessage,hListView,LVM_GETITEMCOUNT,0,0
	mov	ItemID,eax

	mov	LVItem.imask,LVIF_PARAM + LVIF_TEXT + LVIF_IMAGE
	mov	LVItem.iSubItem,0
	mov	eax,Col0
	mov	LVItem.pszText,eax

	mov	eax,Image
	mov	LVItem.iImage,eax
	mov	LVItem.lParam,eax
	mov	eax,ItemID
	mov	LVItem.iItem,eax
	invoke	SendMessage,hListView,LVM_INSERTITEM,0,ADDR LVItem
	mov	ItemID,eax

	mov	eax,Col1
	mov	LVItem.pszText,eax
	mov	eax,ItemID
	mov	LVItem.iItem,eax
	mov	LVItem.iSubItem,1
	mov	LVItem.imask,LVIF_TEXT
	invoke	SendMessage,hListView,LVM_SETITEM,0,ADDR LVItem

	mov	eax,Col2
	mov	LVItem.pszText,eax
	mov	eax,ItemID
	mov	LVItem.iItem,eax
	mov	LVItem.iSubItem,2
	mov	LVItem.imask,LVIF_TEXT
	invoke	SendMessage,hListView,LVM_SETITEM,0,ADDR LVItem

	mov	eax,Col3
	mov	LVItem.pszText,eax
	mov	eax,ItemID
	mov	LVItem.iItem,eax
	mov	LVItem.iSubItem,3
	mov	LVItem.imask,LVIF_TEXT
	invoke	SendMessage,hListView,LVM_SETITEM,0,ADDR LVItem

	mov	eax,ItemID
	ret

LVAddItem endp

ShowLVMenu proc hWin
	LOCAL hPopMenu:DWORD
	LOCAL MCommand:DWORD
	LOCAL lvht:LVHITTESTINFO
	LOCAL lvi:LV_ITEM
	LOCAL pClipData:DWORD

	invoke	GetCursorPos, ADDR lvht.pt
	invoke	ScreenToClient,hWin,ADDR lvht.pt
	invoke	ChildWindowFromPoint, hWin, lvht.pt.x, lvht.pt.y
	cmp	eax,hListView
	jnz	@DONE
	invoke	GetCursorPos, ADDR lvht.pt
	invoke	CreatePopupMenu
	mov	hPopMenu, eax
	invoke	AppendMenu, hPopMenu, MF_STRING, 100, S("Copy")
	invoke	AppendMenu, hPopMenu, MF_STRING, 101, S("Paste")
	invoke	TrackPopupMenu, hPopMenu, TPM_LEFTALIGN + TPM_RETURNCMD,lvht.pt.x, lvht.pt.y, NULL, hListView, NULL
	mov	MCommand,eax
	invoke	ScreenToClient, hListView, ADDR lvht.pt
	mov	lvht.flags,LVHT_ONITEM
	invoke	SendMessage, hListView, LVM_SUBITEMHITTEST, 0, ADDR lvht
	mov	eax,lvht.iItem
	or	eax,eax
	js	@DONE
	cmp	MCommand,100
	jnz	@L1
	mov	lvi.iItem, eax
	invoke	OpenClipboard, hWin
	or	eax,eax
	jz	@DONE
	invoke	EmptyClipboard
	invoke	GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,4096
	mov	hClipData,eax
	invoke	GlobalLock,hClipData
	mov	lvi.pszText, eax
	mov	eax,lvht.iSubItem
	mov	lvi.iSubItem, eax
	mov	lvi.imask, LVIF_TEXT
	mov	lvi.cchTextMax, 4095
	invoke	SendMessage, hListView, LVM_GETITEM, 0, ADDR lvi
	invoke	GlobalUnlock,hClipData
	invoke	SetClipboardData, CF_TEXT, hClipData
	invoke	CloseClipboard
	jmp	@DONE

@L1:
	cmp	MCommand,101
	jnz	@DONE
	mov	lvi.iItem, eax
	mov	eax,lvht.iSubItem
	mov	lvi.iSubItem, eax
	mov	lvi.imask, LVIF_TEXT
	invoke	IsClipboardFormatAvailable, CF_TEXT
	or	eax,eax
	jz	@P2
	invoke	OpenClipboard, hWin
	or	eax,eax
	jz	@P2
	invoke	GetClipboardData, CF_TEXT
	or	eax,eax
	jz	@P1
	push	eax
	invoke	GlobalLock,eax
	mov	lvi.pszText, eax
	invoke	SendMessage, hListView, LVM_SETITEM, 0, ADDR lvi
	pop	eax
	invoke	GlobalUnlock,eax
@P1:
	invoke	CloseClipboard
@P2:
	invoke	DestroyMenu, hPopMenu

@DONE:
	ret

ShowLVMenu endp

LVSortProc proc uses ebx edi esi lParam1,lParam2,lParamSort
	LOCAL ItemData1:LV_ITEM
	LOCAL ItemData2:LV_ITEM
	LOCAL Tbuff1[256]:BYTE
	LOCAL Tbuff2[256]:BYTE

	; lParamSort pointer to LVSORT structure
	mov edi,lParamSort
	mov ebx,[edi.LVSORT].column
	mov esi,[edi.LVSORT].handle

	mov eax,lParam1
	mov ItemData1.iItem,eax
	mov ItemData1.iSubItem,ebx
	mov ItemData1.imask,LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,Tbuff1
	mov ItemData1.pszText,eax
	mov ItemData1.cchTextMax,255
	invoke SendMessage,esi,LVM_GETITEM,0,ADDR ItemData1

	mov eax,lParam2
	mov ItemData2.iItem,eax
	mov ItemData2.iSubItem,ebx
	mov ItemData2.imask,LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,Tbuff2
	mov ItemData2.pszText,eax
	mov ItemData2.cchTextMax,255
	invoke SendMessage,esi,LVM_GETITEM,0,addr ItemData2

	cmp [edi.LVSORT].Gtype,1
	mov edi,[edi.LVSORT].direction
	jb P1
	ja I1
	
	; String sort
	invoke lstrcmpi,addr Tbuff1,addr Tbuff2
	or edi,edi
	jz @f
	neg eax
@@:
	ret

	; lParam sort
P1:
	mov eax,ItemData2.lParam
	mov ecx,ItemData1.lParam
	cmp ecx,eax
	jae @f
	mov eax,-1
	jmp P2
@@:
	jne @F
	mov eax,0
	jmp P2
@@:
	mov eax,1
P2:
	or edi,edi
	jz @F
	neg eax
@@:
	ret

	; Image sort
I1:
	mov eax,ItemData2.iImage
	mov ecx,ItemData1.iImage
	cmp ecx,eax
	jae @F
	mov eax,-1
	jmp @I2
@@:
	jne @F
	mov eax,0
	jmp @I2
@@:
	mov eax,1
@I2:
	or edi,edi
	jz @F
	neg eax
@@:
	ret

LVSortProc endp

DlgProc proc uses edi ebx esi hwnd,uMsg,wParam,lParam
	LOCAL hdi:HDITEM
	LOCAL lvhi:LVHITTESTINFO
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	LOCAL lbr:LOGBRUSH
	LOCAL lvi:LV_ITEM

	.if uMsg==WM_CTLCOLORDLG
		mov eax,hBrush
		ret

	.elseif uMsg==WM_CTLCOLORSTATIC
		invoke GetObject,hBrush,SIZEOF LOGBRUSH,ADDR lbr
		mov ebx,wParam ; hDC
		invoke SetBkColor,ebx,lbr.lbColor
		invoke SetTextColor,ebx,0000FFFFh
		mov eax,hBrush
		ret

	.elseif uMsg==WM_NOTIFY
		mov	edi,lParam
		cmp	[edi.NMHDR].code,HDN_ITEMCLICK
		jnz	@HDN_ITEMCHANGED
		mov	eax,HDI_IMAGE
		or	eax,HDI_FORMAT
		mov	hdi._mask,eax
		invoke	SendMessage,hHeader,HDM_GETITEM,[edi.NMHEADER].iItem,ADDR hdi
		test	hdi.fmt,HDF_IMAGE
		jz	@WMN_DONE
			
		mov	eax,hdimage.dwItem
		or	eax,eax
		js	@H1
		
		cmp	eax,[edi.NMHEADER].iItem
		je	@H2
		
		mov	ecx,0
		invoke	SendMessage,hHeader,HDM_SETITEM,hdimage.dwItem,ADDR hdi
		mov	hdimage.dwDir,1
		mov	ecx,1
		jmp	@H1
@H2:
		mov	ecx,hdimage.dwDir
		test	ecx,1
		je	@F
		
		mov	ecx,2
		jmp	@H1
@@:
		mov	ecx,1
@H1:
		mov	eax,[edi.NMHEADER].iItem
		mov	hdimage.dwItem,eax
		mov	hdi.iImage,ecx
		mov	hdimage.dwDir,ecx
		; D[hdi.iItem] = the header item that was clicked
		; D[hdi.iImage] = the current image
		; set to 0 = no arrow, 1 = down arrow, 2 = up arrow
		invoke	SendMessage,hHeader,HDM_SETITEM,[edi.NMHEADER].iItem,ADDR hdi

		; Sort the column by text based on the direction arrow
		mov	eax,hListView
		mov	Glvsort.handle,eax ; Handle of the listview to sort
		mov	eax,hdimage.dwDir
		shr	eax,1
		mov	Glvsort.direction,eax ; FALSE = ascending , TRUE = descending
		mov	eax,[edi.NMHEADER].iItem
		mov	Glvsort.column,eax ; Column to sort
		mov	Glvsort.Gtype,1 ; 0 = param, 1 = string, 2 = image index
		invoke	SendMessage, hListView, LVM_SORTITEMSEX, offset Glvsort, offset LVSortProc
		jmp	@WMN_DONE

@HDN_ITEMCHANGED:
		cmp	[edi.NMHDR].code,HDN_ITEMCHANGED
		jnz	@NMCLICK
		; Redraw the listview when header resized
		invoke	InvalidateRect,hListView,NULL,NULL
		invoke	UpdateWindow,hListView
		jmp	@WMN_DONE

@NMCLICK:
		cmp	[edi.NMHDR].code,NM_CLICK
		jnz	@NM_CUSTOMDRAW
		invoke	GetMessagePos
		movzx	ecx,ax
		mov	lvhi.pt.x,ecx
		shr	eax,16
		movzx	ecx,ax
		mov	lvhi.pt.y,ecx
		invoke	ScreenToClient,hListView,ADDR lvhi.pt
		invoke	SendMessage,hListView,LVM_SUBITEMHITTEST,0,ADDR lvhi
		; returns the column and item that was clicked in lvhi
		mov	eax,lvhi.iItem
		mov	lvi.iItem,eax
		mov	lvi.iSubItem,0
		mov	lvi.cchTextMax,255
		mov	lvi.pszText,OFFSET buffer
		invoke	SendMessage,hListView,LVM_GETITEMTEXT,lvhi.iItem,ADDR lvi
		invoke	SetDlgItemText,hwnd,1002,OFFSET buffer
		jmp	@WMN_DONE

@NM_CUSTOMDRAW:
		cmp	[edi.NMHDR].code,NM_CUSTOMDRAW
		jne	@WMN_DONE
		mov	eax,wParam
		cmp	eax,1001
		jne	@WMN_DONE
			
		mov	edi,lParam
		mov	eax,[edi.NMLVCUSTOMDRAW.nmcd].dwDrawStage
		cmp	eax,CDDS_PREPAINT
		jne	@F
		
		; Request an item draw notification
		invoke	SetWindowLong,hwnd,DWL_MSGRESULT,CDRF_NOTIFYITEMDRAW
		xor	eax,eax
		inc	eax
		ret
@@:
		cmp	eax,CDDS_ITEMPREPAINT
		jne	@P1
			
		; The item is about to be painted
		; intercept the paint process to do our own thing
		mov	eax,[edi.NMLVCUSTOMDRAW.nmcd].uItemState
		test	eax,CDIS_SELECTED
		je	@F
		
		; A selected item is being drawn
		; Get the item number
		mov	esi,[edi.NMLVCUSTOMDRAW.nmcd].dwItemSpec
		; Get the bounding rect of the icon
		mov	rect.left,LVIR_ICON
		invoke	SendMessage,hListView,LVM_GETITEMRECT,esi,ADDR rect
		push	rect.right
		; Get the bounding rect of the item
		mov	rect.left,LVIR_BOUNDS
		invoke	SendMessage,hListView,LVM_GETITEMRECT,esi,ADDR rect
		pop	ecx ; pop the right side of the icon
		inc	ecx ; one pixel space
		mov	rect.left,ecx

		; Get the device context
		mov	ebx,[edi.NMLVCUSTOMDRAW.nmcd].hdc

		; Draw the background color
		invoke	FillRect,ebx,ADDR rect,hLVBrush

		; Set the text background color
		invoke	GetObject,hLVBrush,SIZEOF LOGBRUSH,ADDR lbr
		invoke	SetBkColor,ebx,lbr.lbColor
		push	eax ; push the old background color
		; Set the text color
		invoke	SetTextColor,ebx,000000FFh
		push	eax ; push the old text color

		; Get the item count from the header control
		invoke	SendMessage,hListView,LVM_GETHEADER,0,0
		invoke	SendMessage,eax,HDM_GETITEMCOUNT,0,0
		mov	ecx,eax

		; Loop through all the labels and draw their text
		mov	lvi.iItem,esi
		mov	lvi.pszText,OFFSET buffer
		mov	lvi.cchTextMax,255
		; EDI is no longer needed so we'll use it for a counter
		xor	edi,edi
		jmp	@W1
@W2:
		push	ecx ; save the item count
		; Get the bounding rect of the label
		; the API uses the rect struct to pass parameters
		mov	rect.left,LVIR_LABEL
		mov	rect.top,edi
		invoke	SendMessage,hListView,LVM_GETSUBITEMRECT,esi,ADDR rect
		or	edi,edi
		jz	@W3
		add	rect.left,4 ; extra indent for sub items
@W3:
		add	rect.left,2 ; indent isn't right with LVM_GETITEM
		mov	lvi.iSubItem,edi
		invoke	SendMessage,hListView,LVM_GETITEMTEXT,esi,ADDR lvi
		; Draw the text to the items
		invoke	DrawText,ebx,OFFSET buffer,-1,ADDR rect,DT_LEFT + DT_VCENTER + DT_SINGLELINE
		pop	ecx ; restore the item count
		inc	edi
@W1:
		cmp	edi,ecx ; have we reached the last item ?
		jl	@W2

		pop	eax ; pop the old text color
		invoke	SetTextColor,ebx,eax
		pop	eax ; pop the old background color
		invoke	SetBkColor,ebx,eax

		; Draw the icon and we're all done !
		mov	lvi.imask,LVIF_IMAGE
		mov	lvi.iItem,esi
		mov	lvi.iSubItem,0
		invoke	SendMessage,hListView,LVM_GETITEM,0,ADDR lvi
		invoke	SendMessage,hListView,LVM_GETIMAGELIST,LVSIL_SMALL,0
		mov	edi,eax
		mov	rect.left,LVIR_ICON
		invoke	SendMessage,hListView,LVM_GETITEMRECT,esi,ADDR rect
		invoke	ImageList_Draw,edi,lvi.iImage,ebx,rect.left,rect.top,ILD_BLEND50

		; The drawing is all done so skip the default draw
		invoke	SetWindowLong,hwnd,DWL_MSGRESULT,CDRF_SKIPDEFAULT
		xor	eax,eax
		inc	eax
		ret
@@:
		; Set the text and background colors
		mov	[edi.NMLVCUSTOMDRAW].clrTextBk,0FFFFFFh
		mov	[edi.NMLVCUSTOMDRAW].clrText,0FF0000h
		; The item is not selected so use the default draw
		invoke	SetWindowLong,hwnd,DWL_MSGRESULT,CDRF_DODEFAULT
		xor	eax,eax
		inc	eax
		ret
@P1:
		invoke	SetWindowLong,hwnd,DWL_MSGRESULT,CDRF_DODEFAULT
		xor	eax,eax
		inc	eax
		ret

@WMN_DONE:
		xor eax,eax
		ret

	.elseif uMsg==WM_COMMAND

		jmp @EXIT

	.elseif uMsg==WM_CONTEXTMENU
		invoke ShowLVMenu,hwnd
		xor eax,eax
		inc eax
		ret

	.elseif uMsg==WM_DESTROYCLIPBOARD
		invoke GlobalFree,hClipData
		xor eax,eax
		inc eax
		ret

	.elseif uMsg==WM_INITDIALOG
		mov	eax,hwnd
		mov	hDlg,eax
		invoke	SendDlgItemMessage,hDlg,1002,WM_SETFONT,hArialFont,TRUE
		invoke	GetDlgItem,hDlg,1001
		mov	hListView,eax
		invoke	SendMessage,hListView,LVM_GETHEADER,0,0
		mov	hHeader,eax
		call	SetUpListView
		; LVAddItem,iIcon,ptext0,ptext1,ptext2,ptext3
		invoke	LVAddItem,0,S("Item 1"),S("SubItem 6"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,1,S("Item 2"),S("SubItem 1"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,0,S("Item 3"),S("SubItem 7"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,1,S("Item 4"),S("SubItem 0"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,0,S("Item 5"),S("SubItem 4"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,1,S("Item 6"),S("SubItem 3"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,0,S("Item 7"),S("SubItem 5"),OFFSET szColumn2,OFFSET szColumn3
		invoke	LVAddItem,1,S("Item 8"),S("SubItem 2"),OFFSET szColumn2,OFFSET szColumn3

		xor	eax,eax
		inc	eax
		ret

	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hwnd,0
	.else
		xor eax,eax
		ret
	.endif
@EXIT:
	xor eax,eax
	inc eax
	ret

DlgProc endp

SetUpListView proc uses edi esi
	LOCAL LVColumn:LV_COLUMN
	LOCAL hdi:HDITEM

	invoke	ImageList_Create,16,16,ILC_MASK + ILC_COLOR24,1,10
	mov	hIml,eax
	invoke	LoadIcon,hInstance,10000
	push	eax
	invoke	ImageList_AddIcon,hIml,eax
	pop	eax
	invoke	DestroyIcon,eax
	invoke	LoadIcon,hInstance,10001
	push	eax
	invoke	ImageList_AddIcon,hIml,eax
	pop	eax
	invoke	DestroyIcon,eax

	invoke	SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,hIml

	mov	LVColumn.imask,LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov	LVColumn.fmt,LVCFMT_LEFT
	mov	LVColumn.lx,99
	mov	LVColumn.pszText,OFFSET szColumn0
	mov	LVColumn.cchTextMax,SIZEOF szColumn0
	invoke	SendMessage,hListView,LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov	LVColumn.imask,LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov	LVColumn.fmt,LVCFMT_LEFT
	mov	LVColumn.lx,99
	mov	LVColumn.pszText,OFFSET szColumn1
	mov	LVColumn.cchTextMax,SIZEOF szColumn1
	invoke	SendMessage,hListView,LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov	LVColumn.imask,LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov	LVColumn.fmt,LVCFMT_LEFT
	mov	LVColumn.lx,99
	mov	LVColumn.pszText,OFFSET szColumn2
	mov	LVColumn.cchTextMax,SIZEOF szColumn2
	mov	LVColumn.iSubItem,1
	invoke	SendMessage,hListView,LVM_INSERTCOLUMN,2,ADDR LVColumn

	mov	LVColumn.imask,LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov	LVColumn.fmt,LVCFMT_LEFT
	mov	LVColumn.lx,99
	mov	LVColumn.pszText,OFFSET szColumn3
	mov	LVColumn.cchTextMax,SIZEOF szColumn3
	mov	LVColumn.iSubItem,2
	invoke	SendMessage,hListView,LVM_INSERTCOLUMN,3,ADDR LVColumn

	invoke	SendMessage,hListView,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT 

	invoke	ImageList_LoadImage,hInstance,11000,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke	SendMessage,hHeader,HDM_SETIMAGELIST,0,eax
	mov	hdi._mask,HDI_FORMAT + HDI_IMAGE
	mov	hdi.fmt,HDF_IMAGE + HDF_STRING + HDF_BITMAP_ON_RIGHT
	mov	hdi.iImage,0

	invoke	SendMessage,hHeader,HDM_GETITEMCOUNT,0,0
	dec	eax
	mov	edi,eax
@@:
	invoke	SendMessage,hHeader,HDM_SETITEM,edi,ADDR hdi
	dec	edi
	jns	@B

	ret

SetUpListView endp

start:
	invoke	GetModuleHandle, 0
	mov	hInstance,eax
	invoke	CreateSolidBrush,0FF8080h
	mov	hBrush,eax
	invoke	CreateFontIndirect,OFFSET ArialFont
	mov	hArialFont,eax
	invoke	CreateSolidBrush,0000FFFFh ;brush for the listview
	mov	hLVBrush,eax
	invoke	InitCommonControlsEx,OFFSET icc
	invoke	DialogBoxParam,hInstance,1000,0,ADDR DlgProc,0
	invoke	DeleteObject,hBrush
	invoke	DeleteObject,hLVBrush
	invoke	DeleteObject,hArialFont
	invoke	ExitProcess,0

end start

